<?php

namespace Drupal\pcr\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\Plugin\Field\FieldWidget\OptionsButtonsWidget;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'options_pretty' widget.
 *
 * @FieldWidget(
 *   id = "options_pretty",
 *   label = @Translation("Pretty Check boxes/radio buttons"),
 *   field_types = {
 *     "list_string",
 *     "boolean",
 *   },
 *   multiple_values = TRUE
 * )
 */
class PrettyOptionsWidget extends OptionsButtonsWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

    // Set the #pretty_option option for "Pretty Check boxes/radio buttons" Widget.
    $element['#pretty_option'] = TRUE;
    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public static function defaultSettings() {
    return [
      'default_bg_color' => '#f6f6f6',
      'default_font_color'  => '#454545',
      'default_border_color'  => '#c5c5c5',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function settingsForm(array $form, FormStateInterface $form_state) {
    $elements = [];

    // @TODO Be able to select colors for the elements.

    // Default colors
/*    $elements['container_elements'] = [
      '#type' => 'fieldset',
      '#title' => $this->t('Default colors'),
    ];

    $elements['container_elements']['default_bg_color'] = [
      '#type' => 'color',
      '#title' => $this->t('Background'),
      '#default_value' => $this->getSetting('default_bg_color'),
    ];

    $elements['container_elements']['default_font_color'] = [
      '#type' => 'color',
      '#title' => $this->t('Font'),
      '#default_value' => $this->getSetting('default_font_color'),
    ];

    $elements['container_elements']['default_border_color'] = [
      '#type' => 'color',
      '#title' => $this->t('Border'),
      '#default_value' => $this->getSetting('default_border_color'),
    ];*/

    // Checked colors

    return $elements;
  }

}
